package at.ac.uibk.gitsearch.config;

import org.springframework.boot.context.properties.ConfigurationProperties;

/**
 * Properties specific to Gitsearch.
 * <p>
 * Properties are configured in the {@code application.yml} file.
 * See {@link io.github.jhipster.config.JHipsterProperties} for a good example.
 */
@ConfigurationProperties(prefix = "application", ignoreUnknownFields = false)
public class ApplicationProperties {

    private Search search;

    private GitLab gitLab;

    public Search getSearch() {
        return search;
    }

    public void setSearch(Search search) {
        this.search = search;
    }

    public GitLab getGitLab() {
        return gitLab;
    }

    public void setGitLab(GitLab gitLab) {
        this.gitLab = gitLab;
    }

    public static class Search {

        private String highlightPre;
        private String highlightPost;

        public String getHighlightPre() {
            return highlightPre;
        }

        public void setHighlightPre(String highlightPre) {
            this.highlightPre = highlightPre;
        }

        public String getHighlightPost() {
            return highlightPost;
        }

        public void setHighlightPost(String highlightPost) {
            this.highlightPost = highlightPost;
        }
    }

    public static class GitLab {
        private String url;
        private String mainGroup;

        public String getUrl() {
            return url;
        }

        public void setUrl(String url) {
            this.url = url;
        }

        public String getMainGroup() {
            return mainGroup;
        }

        public void setMainGroup(String mainGroup) {
            this.mainGroup = mainGroup;
        }
    }
}
