package at.ac.uibk.gitsearch.service.dto;

import java.util.List;

public class SearchInputDTO {
    private String fulltextQuery;
    private String metadataProgrammingLanguage;
    private String metadataKeywords;
    private String metadataNaturalLanguage;
    private String metadataLicense;
    private String metadataAuthor;
    private List<String> selectedRepository;
    private List<String> selectedUniversity;
    private List<String> selectedFileFormat;

    private int page;

    public SearchInputDTO(String fulltextQuery, String metadataProgrammingLanguage, String metadataKeywords,
                          String metadataNaturalLanguage, String metadataLicense, String metadataAuthor,
                          List<String> selectedRepository, List<String> selectedUniversity,
                          List<String> selectedFileFormat, int page) {
        this.fulltextQuery = fulltextQuery;
        this.metadataProgrammingLanguage = mapEmptyString(metadataProgrammingLanguage);
        this.metadataKeywords = mapEmptyString(metadataKeywords);
        this.metadataNaturalLanguage = mapEmptyString(metadataNaturalLanguage);
        this.metadataLicense = mapEmptyString(metadataLicense);
        this.metadataAuthor = mapEmptyString(metadataAuthor);
        this.selectedRepository = selectedRepository;
        this.selectedUniversity = selectedUniversity;
        this.selectedFileFormat = selectedFileFormat;
        this.page = page;
    }

    private static String mapEmptyString(String str) {
        return "".equals(str) ? null : str;
    }

    public String getFulltextQuery() {
        return fulltextQuery;
    }

    public void setFulltextQuery(String fulltextQuery) {
        this.fulltextQuery = fulltextQuery;
    }

    public String getMetadataProgrammingLanguage() {
        return metadataProgrammingLanguage;
    }

    public void setMetadataProgrammingLanguage(String metadataProgrammingLanguage) {
        this.metadataProgrammingLanguage = metadataProgrammingLanguage;
    }

    public void setMetadataKeywords(String metadataKeywords) {
        this.metadataKeywords = metadataKeywords;
    }

    public String getMetadataKeywords() {
        return metadataKeywords;
    }

    public String getMetadataNaturalLanguage() {
        return metadataNaturalLanguage;
    }

    public void setMetadataNaturalLanguage(String metadataNaturalLanguage) {
        this.metadataNaturalLanguage = metadataNaturalLanguage;
    }

    public String getMetadataLicense() {
        return metadataLicense;
    }

    public void setMetadataLicense(String metadataLicense) {
        this.metadataLicense = metadataLicense;
    }

    public String getMetadataAuthor() {
        return metadataAuthor;
    }

    public void setMetadataAuthor(String metadataAuthor) {
        this.metadataAuthor = metadataAuthor;
    }

    public List<String> getSelectedRepository() {
        return selectedRepository;
    }

    public void setSelectedRepository(List<String> selectedRepository) {
        this.selectedRepository = selectedRepository;
    }

    public List<String> getSelectedUniversity() {
        return selectedUniversity;
    }

    public void setSelectedUniversity(List<String> selectedUniversity) {
        this.selectedUniversity = selectedUniversity;
    }

    public List<String> getSelectedFileFormat() {
        return selectedFileFormat;
    }

    public void setSelectedFileFormat(List<String> selectedFileFormat) {
        this.selectedFileFormat = selectedFileFormat;
    }

    public int getPage() {
        return page;
    }

    public void setPage(int page) {
        this.page = page;
    }

    public boolean hasMetadataInput() {
        return !(metadataProgrammingLanguage == null
            && metadataKeywords == null
            && metadataAuthor == null
            && metadataLicense == null);
    }
}
